package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ListProperty;
import org.eclipse.sapphire.modeling.ModelElementList;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.annotations.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;
import org.eclipse.sapphire.modeling.xml.annotations.XmlListBinding;

@GenerateImpl

public interface IComponentServiceReference extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IComponentServiceReference.class );

    // *** Name ***
    
    @XmlBinding( path = "@name" )
    @Label( standard = "&Name" )
    @NonNullValue

    ValueProperty PROP_NAME = new ValueProperty( TYPE, "Name" );

    Value<String> getName();
    void setName( String value );

    // *** Java Interfaces ***

    @Label( standard = "&Java Interfaces" )
    @Type( base = IInterfaceJava.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "bean:interface.java", type = IInterfaceJava.class ) )
    
    ListProperty PROP_JAVA_INTERFACES = new ListProperty( TYPE, "JavaInterfaces" );
    
    ModelElementList<IInterfaceJava> getJavaInterfaces();

}
