package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;

@GenerateImpl

public interface IImplementationBean extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IImplementationBean.class );

    // *** class ***
    
    @XmlBinding( path = "implementation.bean/@class" )
    @Label( standard = "&class" )
    @NonNullValue

    ValueProperty PROP_IMPL_BEAN_CLASS = new ValueProperty( TYPE, "ImplBeanClass" );

    Value<String> getImplBeanClass();
    void setImplBeanClass ( String value );
}
