package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ListProperty;
import org.eclipse.sapphire.modeling.ModelElementList;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.annotations.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;
import org.eclipse.sapphire.modeling.xml.annotations.XmlListBinding;
import org.eclipse.sapphire.modeling.xml.annotations.XmlNamespace;

@XmlNamespace( uri = "urn:switchyard-component-soap:config:1.0", prefix = "soap" )
@GenerateImpl

public interface IService extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IService.class );

    // *** Name ***
    
    @XmlBinding( path = "@name" )
    @Label( standard = "&Name" )
    @NonNullValue

    ValueProperty PROP_NAME = new ValueProperty( TYPE, "Name" );

    Value<String> getName();
    void setName( String value );

    // *** Promote ***
    
    @XmlBinding( path = "@promote" )
    @Label( standard = "&Promote" )
    @NonNullValue

    ValueProperty PROP_PROMOTE = new ValueProperty( TYPE, "Promote" );

    Value<String> getPromote();
    void setPromote( String value );

    // *** SOAPBindings ***

    @Label( standard = "&SOAP Bindings" )
    @Type( base = ISOAPBinding.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "soap:binding.soap", type = ISOAPBinding.class ) )
    
    ListProperty PROP_SOAPBINDINGS = new ListProperty( TYPE, "SOAPBindings" );
    
    ModelElementList<ISOAPBinding> getSoapbindings();

}
